--- /dev/null	Sun Aug  5 23:41:04 2018
+++ new/usr/src/lib/libc/port/socket/socketpair.c	Sun Aug  5 23:41:04 2018
@@ -0,0 +1,128 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 1997 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+/*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T */
+/*	  All Rights Reserved   */
+
+/*
+ * University Copyright- Copyright (c) 1982, 1986, 1988
+ * The Regents of the University of California
+ * All Rights Reserved
+ *
+ * University Acknowledgment- Portions of this document are derived from
+ * software developed by the University of California, Berkeley, and its
+ * contributors.
+ */
+
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/stropts.h>
+#include <sys/stream.h>
+#include <sys/socketvar.h>
+#include <errno.h>
+#include <unistd.h>
+#include <stdlib.h>
+
+extern int _so_socket(int, int, int, dev_t, int);
+extern int _so_socketpair(int *);
+
+int _socketpair_create(int, int, int, int*, int);
+
+#pragma weak socketpair = _socketpair
+
+int
+_socketpair(int family, int type, int protocol, int sv[2])
+{
+	return (_socketpair_create(family, type, protocol, sv, SOV_DEFAULT));
+}
+
+/*
+ * Used by the BCP library.
+ */
+int
+_socketpair_bsd(int family, int type, int protocol, int sv[2])
+{
+	return (_socketpair_create(family, type, protocol, sv, SOV_SOCKBSD));
+}
+
+int
+_socketpair_svr4(int family, int type, int protocol, int sv[2])
+{
+	return (_socketpair_create(family, type, protocol, sv,
+				SOV_SOCKSTREAM));
+}
+
+int
+__xnet_socketpair(int family, int type, int protocol, int sv[2])
+{
+	return (_socketpair_create(family, type, protocol, sv,
+				SOV_XPG4_2));
+}
+
+int
+_socketpair_create(int family, int type, int protocol, int sv[2], int version)
+{
+	int res;
+	int fd1, fd2;
+
+	/*
+	 * Create the two sockets and pass them to _so_socketpair, which
+	 * will connect them together.
+	 */
+	fd1 = _so_socket(family, type, protocol, NULL, version);
+	if (fd1 < 0)
+		return (-1);
+	fd2 = _so_socket(family, type, protocol, NULL, version);
+	if (fd2 < 0) {
+		int error = errno;
+
+		(void) close(fd1);
+		errno = error;
+		return (-1);
+	}
+	sv[0] = fd1;
+	sv[1] = fd2;
+	res = _so_socketpair(sv);
+	if (res < 0) {
+		int error = errno;
+
+		(void) close(fd1);
+		(void) close(fd2);
+		errno = error;
+		return (-1);
+	}
+	/*
+	 * Check if kernel returned different fds in which case we close
+	 * the original ones. This is the case for SOCK_STREAM where
+	 * one of the original sockets is used as a listener and
+	 * _so_socketpair passes out the newly accepted socket.
+	 */
+	if (sv[0] != fd1)
+		(void) close(fd1);
+	if (sv[1] != fd2)
+		(void) close(fd2);
+	return (res);
+}
--- old/usr/src/lib/libc/port/threads/scalls.c	Sun Aug  5 23:41:04 2018
+++ new/usr/src/lib/libc/port/threads/scalls.c	Sun Aug  5 23:41:04 2018
@@ -1067,10 +1067,10 @@
 }
 
 int
-_so_accept(int sock, struct sockaddr *addr, uint_t *addrlen, int version,
-    int flags)
+_so_accept(int sock, struct sockaddr *addr, socklen_t *addrlen,
+    int version, int flags)
 {
-	extern int __so_accept(int, struct sockaddr *, uint_t *, int, int);
+	extern int __so_accept(int, struct sockaddr *, socklen_t *, int, int);
 	int rv;
 
 	PERFORM(__so_accept(sock, addr, addrlen, version, flags))
@@ -1077,67 +1077,68 @@
 }
 
 int
-_so_connect(int sock, struct sockaddr *addr, uint_t addrlen, int version)
+_so_connect(int sock, const struct sockaddr *addr, socklen_t addrlen,
+    int version)
 {
-	extern int __so_connect(int, struct sockaddr *, uint_t, int);
+	extern int __so_connect(int, const struct sockaddr *, socklen_t, int);
 	int rv;
 
 	PERFORM(__so_connect(sock, addr, addrlen, version))
 }
 
-int
+ssize_t
 _so_recv(int sock, void *buf, size_t len, int flags)
 {
-	extern int __so_recv(int, void *, size_t, int);
+	extern ssize_t __so_recv(int, void *, size_t, int);
 	int rv;
 
 	PERFORM(__so_recv(sock, buf, len, flags))
 }
 
-int
-_so_recvfrom(int sock, void *buf, size_t len, int flags,
-    struct sockaddr *addr, int *addrlen)
+ssize_t
+_so_recvfrom(int sock, void *buf, size_t len, int flags, struct sockaddr *addr,
+    socklen_t *addrlen)
 {
-	extern int __so_recvfrom(int, void *, size_t, int,
-	    struct sockaddr *, int *);
+	extern ssize_t __so_recvfrom(int, void *, size_t, int,
+	    struct sockaddr *, socklen_t *);
 	int rv;
 
 	PERFORM(__so_recvfrom(sock, buf, len, flags, addr, addrlen))
 }
 
-int
+ssize_t
 _so_recvmsg(int sock, struct msghdr *msg, int flags)
 {
-	extern int __so_recvmsg(int, struct msghdr *, int);
+	extern ssize_t __so_recvmsg(int, struct msghdr *, int);
 	int rv;
 
 	PERFORM(__so_recvmsg(sock, msg, flags))
 }
 
-int
+ssize_t
 _so_send(int sock, const void *buf, size_t len, int flags)
 {
-	extern int __so_send(int, const void *, size_t, int);
+	extern ssize_t __so_send(int, const void *, size_t, int);
 	int rv;
 
 	PERFORM(__so_send(sock, buf, len, flags))
 }
 
-int
+ssize_t
 _so_sendmsg(int sock, const struct msghdr *msg, int flags)
 {
-	extern int __so_sendmsg(int, const struct msghdr *, int);
+	extern ssize_t __so_sendmsg(int, const struct msghdr *, int);
 	int rv;
 
 	PERFORM(__so_sendmsg(sock, msg, flags))
 }
 
-int
+ssize_t
 _so_sendto(int sock, const void *buf, size_t len, int flags,
-    const struct sockaddr *addr, int *addrlen)
+    const struct sockaddr *addr, socklen_t addrlen)
 {
-	extern int __so_sendto(int, const void *, size_t, int,
-	    const struct sockaddr *, int *);
+	extern ssize_t __so_sendto(int, const void *, size_t, int,
+	    const struct sockaddr *, socklen_t);
 	int rv;
 
 	PERFORM(__so_sendto(sock, buf, len, flags, addr, addrlen))
--- old/usr/src/lib/libdhcpagent/Makefile.com	Sun Aug  5 23:41:04 2018
+++ new/usr/src/lib/libdhcpagent/Makefile.com	Sun Aug  5 23:41:04 2018
@@ -34,12 +34,12 @@
 
 LIBS =		$(DYNLIB) $(LINTLIB)
 
-LDLIBS +=	-lc -lsocket -ldhcputil -luuid -ldlpi -lcontract
+LDLIBS +=	-lc -ldhcputil -luuid -ldlpi -lcontract
 
 SRCDIR =	../common
 $(LINTLIB) :=	SRCS = $(SRCDIR)/$(LINTSRC)
 
-CFLAGS += 	$(CCVERBOSE) 
+CFLAGS += 	$(CCVERBOSE)
 CERRWARN +=	-_gcc=-Wno-type-limits
 
 .KEEP_STATE:
--- old/usr/src/lib/libilb/Makefile.com	Sun Aug  5 23:41:05 2018
+++ new/usr/src/lib/libilb/Makefile.com	Sun Aug  5 23:41:05 2018
@@ -44,7 +44,6 @@
 
 CFLAGS +=	-mt $(CCVERBOSE)
 CPPFLAGS +=	$(INCS)
-LDLIBS +=	-lsocket
 
 .KEEP_STATE:
 
--- old/usr/src/lib/libipmi/Makefile.com	Sun Aug  5 23:41:05 2018
+++ new/usr/src/lib/libipmi/Makefile.com	Sun Aug  5 23:41:05 2018
@@ -52,9 +52,9 @@
 
 SRCDIR=		../common
 
-CLEANFILES +=	$(SRCDIR)/ipmi_tables.c	
+CLEANFILES +=	$(SRCDIR)/ipmi_tables.c
 INCS +=		-I$(SRCDIR)
-LDLIBS +=	-lc -lm -lnvpair -lsocket -lnsl
+LDLIBS +=	-lc -lm -lnvpair -lnsl
 CPPFLAGS +=	$(INCS)
 CSTD = $(CSTD_GNU99)
 
--- old/usr/src/lib/libslp/Makefile.com	Sun Aug  5 23:41:05 2018
+++ new/usr/src/lib/libslp/Makefile.com	Sun Aug  5 23:41:05 2018
@@ -36,7 +36,7 @@
 include ../../Makefile.lib
 
 LIBS =		$(DYNLIB) $(LINTLIB)
-LDLIBS +=	-lc -lnsl -lsocket
+LDLIBS +=	-lc -lnsl
 $(LINTLIB):=	SRCS = $(SRCDIR)/$(LINTSRC)
 
 SRCDIR =	../clib
--- old/usr/src/lib/libsocket/Makefile.com	Sun Aug  5 23:41:05 2018
+++ new/usr/src/lib/libsocket/Makefile.com	Sun Aug  5 23:41:05 2018
@@ -26,14 +26,12 @@
 LIBRARY	=	libsocket.a
 VERS =		.1
 
-INETOBJS =	bindresvport.o bootparams_getbyname.o ether_addr.o \
+OBJECTS =	bindresvport.o bootparams_getbyname.o ether_addr.o \
 		getaddrinfo.o getnameinfo.o getnetent.o getnetent_r.o \
 		getprotoent.o getprotoent_r.o getservbyname_r.o getservent.o \
 		getservent_r.o inet6_opt.o inet6_rthdr.o interface_id.o \
 		link_addr.o netmasks.o rcmd.o rexec.o ruserpass.o \
 		sourcefilter.o getifaddrs.o
-SOCKOBJS =	_soutil.o sockatmark.o socket.o socketpair.o weaks.o
-OBJECTS	=	$(INETOBJS) $(SOCKOBJS)
 
 include ../../Makefile.lib
 
@@ -42,7 +40,7 @@
 
 LIBS =		$(DYNLIB) $(LINTLIB)
 
-SRCS =		$(INETOBJS:%.o=../inet/%.c) $(SOCKOBJS:%.o=../socket/%.c)
+SRCS =		$(OBJECTS:%.o=../inet/%.c)
 LDLIBS +=	-lnsl -lc
 
 SRCDIR =	../common
--- old/usr/src/lib/libsocket/common/mapfile-vers	Sun Aug  5 23:41:06 2018
+++ new/usr/src/lib/libsocket/common/mapfile-vers	Sun Aug  5 23:41:06 2018
@@ -49,7 +49,7 @@
 
 SYMBOL_VERSION ILLUMOS_0.1 {    # illumos additions
     global:
-	accept4;
+	accept4			{ TYPE = FUNCTION; FILTER = libc.so.1 };
 } SUNW_1.7;
 
 SYMBOL_VERSION SUNW_1.7 {
@@ -81,7 +81,7 @@
 	inet6_rth_reverse;
 	inet6_rth_segments;
 	inet6_rth_space;
-	sockatmark;
+	sockatmark		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	__xnet_getaddrinfo;
 } SUNW_1.4;
 
@@ -118,15 +118,15 @@
 
 SYMBOL_VERSION SUNW_1.1 {
     global:
-	__xnet_bind;
-	__xnet_connect;
-	__xnet_getsockopt;
-	__xnet_listen;
-	__xnet_recvmsg;
-	__xnet_sendmsg;
-	__xnet_sendto;
-	__xnet_socket;
-	__xnet_socketpair;
+	__xnet_bind		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_connect		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_getsockopt	{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_listen		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_recvmsg		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_sendmsg		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_sendto		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_socket		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_socketpair	{ TYPE = FUNCTION; FILTER = libc.so.1 };
 } SUNW_0.7;
 
 SYMBOL_VERSION SUNW_0.7 {
@@ -163,7 +163,7 @@
 	setnetent;
 	setprotoent;
 	setservent;
-	socketpair;
+	socketpair		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 
 	# For ABI reasons, the following symbols are in SISCD_2.3 on 32-bit
 	# sparc, which is inherited by SUNW_0.7. On all other platforms,
@@ -174,30 +174,30 @@
 SYMBOL_VERSION SISCD_2.3 {
     global:
 $endif
-	accept;
-	bind;
-	connect;
-	getpeername;
+	accept			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	bind			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	connect			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	getpeername		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	getprotobyname;
 	getprotobynumber;
 	getprotoent;
 	getservbyname;
 	getservbyport;
-	getsockname;
-	getsockopt;
+	getsockname		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	getsockopt		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	inet_lnaof		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	inet_makeaddr		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	inet_network		{ TYPE = FUNCTION; FILTER = libc.so.1 };
-	listen;
-	recv;
-	recvfrom;
-	recvmsg;
-	send;
-	sendmsg;
-	sendto;
-	setsockopt;
-	shutdown;
-	socket;
+	listen			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	recv			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	recvfrom		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	recvmsg			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	send			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	sendmsg			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	sendto			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	setsockopt		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	shutdown		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	socket			{ TYPE = FUNCTION; FILTER = libc.so.1 };
 };
 
 # There really should be only one SUNWprivate version.
@@ -205,7 +205,7 @@
 
 SYMBOL_VERSION SUNWprivate_1.3 {
     global:
-	_accept4;
+	_accept4		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	_link_aton;
 	_link_ntoa;
 	_nss_initf_ethers;
@@ -229,29 +229,29 @@
 
 SYMBOL_VERSION SUNWprivate_1.1 {
     global:
-	_accept;
-	_bind;
+	_accept			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_bind			{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	bindresvport;
 	bootparams_getbyname;
-	_connect;
-	_getpeername;
-	_getsockname;
-	_getsockopt;
-	_listen;
-	_recv;
-	_recvfrom;
-	_recvmsg;
+	_connect		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_getpeername		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_getsockname		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_getsockopt		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_listen			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_recv			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_recvfrom		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_recvmsg		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	rresvport_addr;
 	_ruserpass;
-	_send;
-	_sendmsg;
-	_sendto;
-	_setsockopt;
-	_shutdown;
-	_socket;
-	_socket_bsd;
-	_socketpair;
-	_socketpair_bsd;
+	_send			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_sendmsg		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_sendto			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_setsockopt		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_shutdown		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_socket			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_socket_bsd		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_socketpair		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	_socketpair_bsd		{ TYPE = FUNCTION; FILTER = libc.so.1 };
     local:
 	*;
 };
--- old/usr/src/lib/libstmfproxy/Makefile.com	Sun Aug  5 23:41:06 2018
+++ new/usr/src/lib/libstmfproxy/Makefile.com	Sun Aug  5 23:41:06 2018
@@ -38,7 +38,7 @@
 
 CSTD=	$(CSTD_GNU99)
 C99LMODE=	-Xc99=%all
-LDLIBS +=	-lc -lsocket -lnsl
+LDLIBS +=	-lc -lnsl
 CPPFLAGS +=	$(INCS) -D_REENTRANT
 
 $(LINTLIB) := SRCS=	$(SRCDIR)/$(LINTSRC)
--- old/usr/src/lib/libvrrpadm/Makefile.com	Sun Aug  5 23:41:06 2018
+++ new/usr/src/lib/libvrrpadm/Makefile.com	Sun Aug  5 23:41:06 2018
@@ -33,7 +33,7 @@
 #include ../../Makefile.rootfs
 
 LIBS =		$(DYNLIB) $(LINTLIB)
-LDLIBS +=	-lc -lsocket -ldladm -lscf
+LDLIBS +=	-lc -ldladm -lscf
 
 SRCDIR =	../common
 $(LINTLIB) :=	SRCS = $(SRCDIR)/$(LINTSRC)
--- old/usr/src/lib/libxnet/common/mapfile-vers	Sun Aug  5 23:41:07 2018
+++ new/usr/src/lib/libxnet/common/mapfile-vers	Sun Aug  5 23:41:07 2018
@@ -58,7 +58,7 @@
 	if_indextoname		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	if_nameindex		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	if_nametoindex		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	sockatmark		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	sockatmark		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 } SUNW_1.2;
 
 SYMBOL_VERSION SUNW_1.2 {
@@ -77,15 +77,15 @@
 SYMBOL_VERSION SUNW_1.1 {
     global:
 	__t_errno		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
-	__xnet_bind		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_connect		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_getsockopt	{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_listen		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_recvmsg		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_sendmsg		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_sendto		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_socket		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	__xnet_socketpair	{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	__xnet_bind		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_connect		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_getsockopt	{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_listen		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_recvmsg		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_sendmsg		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_sendto		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_socket		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	__xnet_socketpair	{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	_xti_accept		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
 	_xti_alloc		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
 	_xti_bind		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
@@ -113,9 +113,9 @@
 	_xti_strerror		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
 	_xti_sync		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
 	_xti_unbind		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
-	accept			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	bind			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	connect			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	accept			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	bind			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	connect			{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	endhostent		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
 	endnetent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	endprotoent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
@@ -127,7 +127,7 @@
 	getnetbyaddr		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	getnetbyname		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	getnetent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	getpeername		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	getpeername		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	getprotobyname		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	getprotobynumber	{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	getprotoent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
@@ -134,8 +134,8 @@
 	getservbyname		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	getservbyport		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	getservent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	getsockname		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	getsockopt		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	getsockname		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	getsockopt		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	h_errno {
 		TYPE = DATA;
 		SIZE = 0x4;
@@ -150,23 +150,23 @@
 	inet_netof		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	inet_network		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	inet_ntoa		{ TYPE = FUNCTION; FILTER = libc.so.1 };
-	listen			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	listen			{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	ntohl			{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	ntohs			{ TYPE = FUNCTION; FILTER = libc.so.1 };
-	recv			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	recvfrom		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	recvmsg			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	send			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	sendmsg			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	sendto			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	recv			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	recvfrom		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	recvmsg			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	send			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	sendmsg			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	sendto			{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	sethostent		{ TYPE = FUNCTION; FILTER = libnsl.so.1 };
 	setnetent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	setprotoent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
 	setservent		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	setsockopt		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	shutdown		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	socket			{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
-	socketpair		{ TYPE = FUNCTION; FILTER = libsocket.so.1 };
+	setsockopt		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	shutdown		{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	socket			{ TYPE = FUNCTION; FILTER = libc.so.1 };
+	socketpair		{ TYPE = FUNCTION; FILTER = libc.so.1 };
 	t_errno {
 		TYPE = DATA;
 		SIZE = 0x4;
--- old/usr/src/lib/print/libipp-listener/Makefile.com	Sun Aug  5 23:41:07 2018
+++ new/usr/src/lib/print/libipp-listener/Makefile.com	Sun Aug  5 23:41:07 2018
@@ -57,7 +57,7 @@
 
 MAPFILES =	$(SRCDIR)/mapfile
 
-LDLIBS +=	-lipp-core -lpapi -lc -lsocket -lnsl
+LDLIBS +=	-lipp-core -lpapi -lc -lnsl
 
 .KEEP_STATE:
 
--- old/usr/src/lib/print/libpapi-common/Makefile.com	Sun Aug  5 23:41:07 2018
+++ new/usr/src/lib/print/libpapi-common/Makefile.com	Sun Aug  5 23:41:07 2018
@@ -45,7 +45,7 @@
 
 MAPFILES =	$(SRCDIR)/mapfile
 
-LDLIBS +=	-lc -lsocket -lnsl
+LDLIBS +=	-lc -lnsl
 
 .KEEP_STATE:
 
--- old/usr/src/man/man3c/Makefile	Sun Aug  5 23:41:08 2018
+++ new/usr/src/man/man3c/Makefile	Sun Aug  5 23:41:08 2018
@@ -27,6 +27,7 @@
 		a64l.3c						\
 		abort.3c					\
 		abs.3c						\
+		accept.3c					\
 		addsev.3c					\
 		addseverity.3c					\
 		aio_cancel.3c					\
@@ -55,6 +56,7 @@
 		atomic_swap.3c					\
 		attropen.3c					\
 		basename.3c					\
+		bind.3c						\
 		bsd_signal.3c					\
 		bsearch.3c					\
 		bstring.3c					\
@@ -73,6 +75,7 @@
 		cnd.3c						\
 		cond_init.3c					\
 		confstr.3c					\
+		connect.3c					\
 		crypt.3c					\
 		crypt_genhash_impl.3c				\
 		crypt_gensalt.3c				\
@@ -179,6 +182,7 @@
 		getpagesize.3c					\
 		getpagesizes.3c					\
 		getpass.3c					\
+		getpeername.3c					\
 		getpeerucred.3c					\
 		getpriority.3c					\
 		getprogname.3c					\
@@ -186,6 +190,8 @@
 		getpwnam.3c					\
 		getrusage.3c					\
 		gets.3c						\
+		getsockname.3c					\
+		getsockopt.3c					\
 		getspnam.3c					\
 		getsubopt.3c					\
 		gettext.3c					\
@@ -224,6 +230,7 @@
 		lckpwdf.3c					\
 		lfmt.3c						\
 		lio_listio.3c					\
+		listen.3c					\
 		localeconv.3c					\
 		lockf.3c					\
 		lsearch.3c					\
@@ -381,6 +388,7 @@
 		readdir.3c					\
 		realpath.3c					\
 		reboot.3c					\
+		recv.3c						\
 		regcmp.3c					\
 		regcomp.3c					\
 		remove.3c					\
@@ -409,6 +417,7 @@
 		sem_unlink.3c					\
 		sem_wait.3c					\
 		semaphore.3c					\
+		send.3c						\
 		setbuf.3c					\
 		setbuffer.3c					\
 		setcat.3c					\
@@ -419,6 +428,7 @@
 		setlocale.3c					\
 		shm_open.3c					\
 		shm_unlink.3c					\
+		shutdown.3c					\
 		sigfpe.3c					\
 		siginterrupt.3c					\
 		signal.3c					\
@@ -429,6 +439,9 @@
 		sigwaitinfo.3c					\
 		sleep.3c					\
 		smt_pause.3c					\
+		sockaddr.3c					\
+		socket.3c					\
+		socketpair.3c					\
 		ssignal.3c					\
 		stack_getbounds.3c				\
 		stack_inbounds.3c				\
@@ -558,7 +571,7 @@
 		wordexp.3c					\
 		wsprintf.3c					\
 		wsscanf.3c					\
-		wstring.3c					\
+		wstring.3c
 
 MANLINKS=	FD_CLR.3c				\
 		FD_ISSET.3c				\
@@ -578,6 +591,7 @@
 		_exithandle.3c				\
 		_flushlbf.3c				\
 		_setjmp.3c				\
+		accept4.3c				\
 		addrtosymstr.3c				\
 		aiowrite.3c				\
 		alloca.3c				\
@@ -1151,6 +1165,8 @@
 		realloc.3c				\
 		reallocarray.3c				\
 		recallocarray.3c			\
+		recvfrom.3c				\
+		recvmsg.3c				\
 		regerror.3c				\
 		regex.3c				\
 		regexec.3c				\
@@ -1179,6 +1195,8 @@
 		sema_post.3c				\
 		sema_trywait.3c				\
 		sema_wait.3c				\
+		sendmsg.3c				\
+		sendto.3c				\
 		setattrat.3c				\
 		setgrent.3c				\
 		sethostname.3c				\
@@ -1188,6 +1206,7 @@
 		setpriority.3c				\
 		setprogname.3c				\
 		setpwent.3c				\
+		setsockopt.3c				\
 		setspent.3c				\
 		setstate.3c				\
 		settimeofday.3c				\
@@ -1213,6 +1232,12 @@
 		sigtimedwait.3c				\
 		single_to_decimal.3c			\
 		snprintf.3c				\
+		sockaddr_dl.3c				\
+		sockaddr_in.3c				\
+		sockaddr_in6.3c				\
+		sockaddr_ll.3c				\
+		sockaddr_storage.3c			\
+		sockaddr_un.3c				\
 		sprintf.3c				\
 		srand.3c				\
 		srand48.3c				\
@@ -1436,6 +1461,8 @@
 labs.3c					:= LINKSRC = abs.3c
 llabs.3c				:= LINKSRC = abs.3c
 
+accept4.3c				:= LINKSRC = accept.3c
+
 aiowrite.3c				:= LINKSRC = aioread.3c
 
 arc4random_buf.3c			:= LINKSRC = arc4random.3c
@@ -1829,6 +1856,8 @@
 
 fgets.3c				:= LINKSRC = gets.3c
 
+setsockopt.3c				:= LINKSRC = getsockopt.3c
+
 endspent.3c				:= LINKSRC = getspnam.3c
 fgetspent.3c				:= LINKSRC = getspnam.3c
 fgetspent_r.3c				:= LINKSRC = getspnam.3c
@@ -2222,6 +2251,9 @@
 
 readdir_r.3c				:= LINKSRC = readdir.3c
 
+recvfrom.3c				:= LINKSRC = recv.3c
+recvmsg.3c				:= LINKSRC = recv.3c
+
 regex.3c				:= LINKSRC = regcmp.3c
 
 regerror.3c				:= LINKSRC = regcomp.3c
@@ -2267,6 +2299,9 @@
 sema_trywait.3c				:= LINKSRC = semaphore.3c
 sema_wait.3c				:= LINKSRC = semaphore.3c
 
+sendmsg.3c				:= LINKSRC = send.3c
+sendto.3c				:= LINKSRC = send.3c
+
 setvbuf.3c				:= LINKSRC = setbuf.3c
 
 setlinebuf.3c				:= LINKSRC = setbuffer.3c
@@ -2289,6 +2324,13 @@
 
 sigtimedwait.3c				:= LINKSRC = sigwaitinfo.3c
 
+sockaddr_dl.3c				:= LINKSRC = sockaddr.3c
+sockaddr_in.3c				:= LINKSRC = sockaddr.3c
+sockaddr_in6.3c				:= LINKSRC = sockaddr.3c
+sockaddr_ll.3c				:= LINKSRC = sockaddr.3c
+sockaddr_storage.3c			:= LINKSRC = sockaddr.3c
+sockaddr_un.3c				:= LINKSRC = sockaddr.3c
+
 gsignal.3c				:= LINKSRC = ssignal.3c
 
 stderr.3c				:= LINKSRC = stdio.3c
--- /dev/null	Sun Aug  5 23:41:08 2018
+++ new/usr/src/man/man3c/accept.3c	Sun Aug  5 23:41:08 2018
@@ -0,0 +1,263 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (C) 2002, Sun Microsystems, Inc. All Rights Reserved
+.\" Copyright (c) 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt ACCEPT 3C
+.Os
+.Sh NAME
+.Nm accept
+.Nd accept a connection on a socket
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo accept
+.Fa "int s"
+.Fa "struct sockaddr *restrict addr"
+.Fa "socklen_t *addrlen"
+.Fc
+.Ft int
+.Fo accept4
+.Fa "int s"
+.Fa "struct sockaddr *restrict addr"
+.Fa "socklen_t *addrlen"
+.Fa "int flags"
+.Fc
+.Sh DESCRIPTION
+The argument
+.Fa s
+is a socket that has been created with
+.Xr socket 3C
+and bound to an address with
+.Xr bind 3C ,
+and that is listening for connections after a call to
+.Xr listen 3C .
+The
+.Fn accept
+function extracts the first connection on the queue of pending connections,
+creates a new socket with the properties of
+.Fa s ,
+and allocates a new file descriptor,
+.Va ns ,
+for the socket.
+If no pending connections are present on the queue and the socket is not marked
+as non-blocking,
+.Fn accept
+blocks the caller until a connection is present.
+If the socket is marked as non-blocking and no pending connections are present
+on the queue,
+.Fn accept
+returns an error as described below.
+The
+.Fn accept
+function uses the
+.Xr netconfig 4
+file to determine the STREAMS device file name associated with
+.Fa s .
+This is the device on which the connect indication will be accepted.
+The accepted socket,
+.Va ns ,
+is used to read and write data to and from the socket that connected to
+.Va ns .
+It is not used to accept more connections.
+The original socket
+.Pq Fa s
+remains open for accepting further connections.
+.Pp
+The argument
+.Fa addr
+is a result parameter that is filled in with the address of the connecting
+entity as it is known to the communications layer.
+The exact format of the
+.Fa addr
+parameter is determined by the domain in which the communication occurs.
+.Pp
+The argument
+.Fa addrlen
+is a value-result parameter.
+Initially, it contains the amount of space pointed to by
+.Fa addr ;
+on return it contains the length in bytes of the address returned.
+.Pp
+The
+.Fn accept
+function is used with connection-based socket types, currently with
+.Dv SOCK_STREAM .
+.Pp
+The
+.Fn accept4
+function allows flags that control the behavior of a successfully accepted
+socket.
+If
+.Fa flags
+is 0,
+.Fn accept4
+acts identically to
+.Fn accept .
+Values for
+.Fa flags
+are constructed by a bitwise-inclusive-OR of flags from the following list,
+defined in
+.In sys/socketvar.h :
+.Bl -tag -width Ds
+.It Dv SOCK_CLOEXEC
+The accepted socket will have the
+.Dv FD_CLOEXEC
+flag set as if
+.Xr fcntl 2
+was called on it.
+This flag is set before the socket is passed to the caller thus avoiding the
+race condition between
+.Fn accept
+and
+.Xr fcntl 2 .
+See
+.Dv O_CLOEXEC
+in
+.Xr open 2
+for more details.
+.It Dv SOCK_NDELAY
+The accepted socket will have the
+.Dv O_NDELAY
+flag set as if
+.Xr fcntl 2
+was called on it.
+This sets the socket into non-blocking mode.
+See
+.Dv O_NDELAY
+in
+.Xr fcntl.h 3HEAD
+for more details.
+.It Dv SOCK_NONBLOCK
+The accepted socket will have the
+.Dv O_NONBLOCK
+flag set as if
+.Xr fcntl 2
+was called on it.
+This sets the socket into non-blocking mode
+.Po POSIX; see
+.Xr standards 5
+.Pc .
+See
+.Dv O_NONBLOCK
+in
+.Xr fcntl.h 3HEAD
+for more details.
+.El
+.Pp
+It is possible to
+.Xr select 3C
+or
+.Xr poll 2
+a socket for the purpose of an
+.Fn accept
+by selecting or polling it for a read.
+However, this will only indicate when a connect indication is pending; it is
+still necessary to call
+.Fn accept .
+.Sh RETURN VALUES
+The
+.Fn accept
+function returns -1 on error.
+If it succeeds, it returns a non-negative integer that is a descriptor for the
+accepted socket.
+.Sh ERRORS
+.Fn accept
+and
+.Fn accept4
+will fail if:
+.Bl -tag -width Er
+.It Bq Er EBADF
+The descriptor is invalid.
+.It Bq Er ECONNABORTED
+The remote side aborted the connection before the
+.Fn accept
+operation completed.
+.It Bq Er EFAULT
+The
+.Fa addr
+parameter or the
+.Fa addrlen
+parameter is invalid.
+.It Bq Er EINTR
+The
+.Fn accept
+attempt was interrupted by the delivery of a signal.
+.It Bq Er EMFILE
+The per-process descriptor table is full.
+.It Bq Er ENODEV
+The protocol family and type corresponding to
+.Fa s
+could not be found in the
+.Pa netconfig
+file.
+.It Bq Er ENOMEM
+There was insufficient user memory available to complete the operation.
+.It Bq Er ENOSR
+There were insufficient STREAMS resources available to complete the operation.
+.It Bq Er ENOTSOCK
+The descriptor does not reference a socket.
+.It Bq Er EOPNOTSUPP
+The referenced socket is not of type
+.Dv SOCK_STREAM .
+.It Bq Er EPROTO
+A protocol error has occurred; for example, the STREAMS protocol stack has not
+been initialized or the connection has already been released.
+.It Bq Er EWOULDBLOCK
+The socket is marked as non-blocking and no connections are present to be
+accepted.
+.El
+.Pp
+Additionally,
+.Fn accept4
+will fail if:
+.Bl -tag -width Er
+.It Bq Er EINVAL
+The
+.Fa flags
+value is invalid.
+The
+.Fa flags
+argument can only be the bitwise inclusive-OR of
+.Dv SOCK_CLOEXEC ,
+.Dv SOCK_NONBLOCK ,
+and
+.Dv SOCK_NDELAY .
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr fcntl 2 ,
+.Xr poll 2 ,
+.Xr bind 3C ,
+.Xr connect 3C ,
+.Xr listen 3C ,
+.Xr select 3C ,
+.Xr sockaddr 3C ,
+.Xr socket 3C ,
+.Xr fcntl.h 3HEAD ,
+.Xr socket.h 3HEAD ,
+.Xr netconfig 4 ,
+.Xr attributes 5 ,
+.Xr standards 5
